#include <math.h>
#include <stdio.h>
#include <stdlib.h>

void WriteMesh(char *name, int rcount, int m, int n)
{
    FILE  *dat;
    float stept, stepu, t, u, x, y, z;
    int   i, j;

    dat = fopen(name, "w");
    fprintf(dat, "%d %d\n", m + 1, n + 1);
    stept = M_PI * (float)rcount / (float)m;
    stepu = 2.0 / (float)n;
    t = 0.0;
    for (i = 0; i <= m; i++) {
        u = -1.0;
        for (j = 0; j <= n; j++) {
            x = u * sin(t);
            y = u * cos(t);
            z = t / 3.0;
            fprintf(dat, "%f %f %f\n", x, y, z);
            u += stepu;
        }
        t += stept;
    }
    fclose(dat);
}

void main(int argc, char *argv[])
{
    if (argc < 2)
        printf("Usage : HELICOID <output file name> <rotation count> <mesh M size> <mesh N size>");
    else if (argc < 3)
        WriteMesh(argv[1], 5, 60, 6);
    else if (argc < 4)
        WriteMesh(argv[1], atoi(argv[2]), 60, 6);
    else if (argc < 5)
        WriteMesh(argv[1], atoi(argv[2]), atoi(argv[3]), 6);
    else
        WriteMesh(argv[1], atoi(argv[2]), atoi(argv[3]), atoi(argv[4]));
}
